using System;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace Bespoke.Games.Framework
{
    /// <summary>
    /// 
    /// </summary>
    public class Sprite
    {
        /// <summary>
        /// 
        /// </summary>
        public Point Position
        {
            get
            {
                return mPosition;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public Vector2 Velocity
        {
            get
            {
                return mVelocity;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public Texture2D Texture
        {
            get
            {
                return mTexture;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public Rectangle Rectangle
        {
            get
            {
                return new Rectangle(mPosition.X, mPosition.Y, mTexture.Width, mTexture.Height);
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public int Width
        {
            get
            {
                return mTexture.Width;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public int Height
        {
            get
            {
                return mTexture.Height;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="graphicsDevice"></param>
        /// <param name="textureFileName"></param>
        /// <param name="position"></param>
        public Sprite(GraphicsDevice graphicsDevice, Texture2D texture, Point position)
            : this(graphicsDevice, texture, position.X, position.Y)
        {
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="graphicsDevice"></param>
        /// <param name="textureFileName"></param>
        /// <param name="x"></param>
        /// <param name="y"></param>
        public Sprite(GraphicsDevice graphicsDevice, Texture2D texture, int x, int y)
        {
            mTexture = texture;
            mPosition = new Point(x, y);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public virtual void Update(GameTime gameTime)
        {
            mPosition.X += (int)mVelocity.X;
            mPosition.Y += (int)mVelocity.Y;
        }

        protected Texture2D mTexture;
        protected Point mPosition;
        protected Vector2 mVelocity;
    }
}
