using System;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using ColorMatching.Content;

namespace ColorMatching
{
    /// <summary>
    /// 
    /// </summary>
    public static class MacbethColorChecker
    {
        /// <summary>
        /// 
        /// </summary>
        public static Spectrum[] Patches
        {
            get
            {
                return mPatches;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        static MacbethColorChecker()
        {
            mPatches = new Spectrum[MaxPatches];
            for (int i = 0; i < MaxPatches; i++)
            {
                mPatches[i] = new Spectrum();
            }

            string[] stringEntries = Resources.MacbethColorChecker.Split("\n".ToCharArray());
            foreach (string stringEntry in stringEntries)
            {
                if (stringEntry == String.Empty)
                {
                    continue;
                }

                string[] stringValues = stringEntry.Split(",".ToCharArray());
                float waveLength = float.Parse(stringValues[0]);
                float value;

                for (int patchIndex = 0; patchIndex < MaxPatches; patchIndex++)
                {
                    value = float.Parse(stringValues[patchIndex+1]);
                    mPatches[patchIndex].Add(new SpectrumSample(waveLength, value));
                }
            }            
        }

        private static readonly int MaxPatches = 24;
        private static Spectrum[] mPatches;
    }
}
